%if 0%{?fedora}
%global with_python3 1
%endif

%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2:        %global __python2 /usr/bin/python2}
%{!?python2_sitelib:  %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%global modname anykeystore

Name:           python-%{modname}
Version:        0.2
Release:        8%{?dist}
Summary:        A key-value store supporting multiple backends
Group:          Development/Libraries
License:        MIT
URL:            http://pypi.python.org/pypi/%{modname}
Source0:        http://pypi.python.org/packages/source/a/%{modname}/%{modname}-%{version}.tar.gz
Patch0:         python-anykeystore-use-unittest1.patch

BuildArch:      noarch

BuildRequires:  python2-devel
BuildRequires:  python-setuptools
BuildRequires:  python-nose
BuildRequires:  python-mock

# Optional backends for the tests
BuildRequires:  python-sqlalchemy
BuildRequires:  pymongo
BuildRequires:  python-redis
BuildRequires:  python-memcached

%if 0%{?with_python3}
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-nose
BuildRequires:  python3-mock

# Optional backends for the tests
BuildRequires:  python3-sqlalchemy
BuildRequires:  python3-pymongo
BuildRequires:  python3-redis
#BuildRequires:  python3-memcached  # Not yet packaged..
%endif

%description
A generic interface wrapping multiple different backends to provide a
consistent key-value storage API. This library is intended to be used by
other libraries that require some form of generic storage.

%if 0%{?with_python3}
%package -n python3-%{modname}
Summary:        A key-value store supporting multiple backends
Group:          Development/Libraries

%description -n python3-%{modname}
A generic interface wrapping multiple different backends to provide a
consistent key-value storage API. This library is intended to be used by
other libraries that require some form of generic storage.
%endif

%prep
%setup -q -n %{modname}-%{version}
%patch0 -p1

%if %{?rhel}%{!?rhel:0} >= 6
rm -rf %{modname}/tests/integration/tests.py
%endif

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
rm -rf %{py3dir}/%{modname}/tests/integration/tests.py
%endif

%build
%{__python2} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install -O1 --skip-build --root=%{buildroot}
popd
%endif

%check
%{__python2} setup.py test

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py test
popd
%endif

%files
%doc README.rst LICENSE.txt
%{python2_sitelib}/%{modname}
%{python2_sitelib}/%{modname}-%{version}*

%if 0%{?with_python3}
%files -n python3-%{modname}
%doc README.rst LICENSE.txt
%{python3_sitelib}/%{modname}
%{python3_sitelib}/%{modname}-%{version}*
%endif

%changelog
* Thu Jun 12 2014 Ralph Bean <rbean@redhat.com> - 0.2-8
- Python3 subpackage added.

* Thu Jun 12 2014 Ralph Bean <rbean@redhat.com> - 0.2-7
- Modernized python2 macros.
- Patched out use of unittest1 which fails oddly in rawhide.

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Nov 09 2012 Ralph Bean <rbean@redhat.com> - 0.2-3
- Remove failing test for el6
* Fri Nov 09 2012 Ralph Bean <rbean@redhat.com> - 0.2-2
- Removed CHANGES.txt since its of size zero
* Thu Nov 08 2012 Ralph Bean <rbean@redhat.com> - 0.2-1
- initial package for Fedora
